//Global functions and variables
float eeprom aref = 4.97;//need user to modify this as well
float eeprom mpx2100_supply_V = 5.00;//need user to enter this

//Keyboard   
#ifndef BASE_ADDR                      
//Define values for special keys
//These values are special characters in the ASCII table
//since we will not use those characters, we can redefine the table.
#define BASE_ADDR	200
#define LEFT		1 + BASE_ADDR
#define RIGHT           2 + BASE_ADDR
#define UP              3 + BASE_ADDR
#define DOWN            4 + BASE_ADDR
#define BACKSPACE       0x08		//ASCII default
#define INS		6 + BASE_ADDR
#define DEL		7 + BASE_ADDR
#define HOME		8 + BASE_ADDR
#define END		9 + BASE_ADDR                               
#define F1		10 + BASE_ADDR
#define F2		11 + BASE_ADDR
#define F3		12 + BASE_ADDR
#endif
             
//The following are the 1-byte commands sent to the keyboard           
#define KBD_CMD_RESET 	0xff
#define KBD_CMD_RESEND  0xfe
#define KBD_CMD_DISABLE	0xf5
#define KBD_CMD_ENABLE	0xf4
#define KBD_CMD_SET_TYP_RATE	0xf3 //set typematic repeat rate
#define KBD_CMD_SCANCODE_SET 	0xf0 //change or read scancode set
#define KBD_CMD_ECHO	0xee
#define KBD_CMD_LED	0xed //set status leds

#define kbd_clk_port  PORTD.2
#define kbd_data_port PORTD.3
#define kbd_clk_pin   PIND.2
#define kbd_data_pin  PIND.3
#define kbd_clk_dir   DDRD.2
#define kbd_data_dir  DDRD.3           

//keyboard circular buffer
#define KBD_BUF_SIZE 8U //to be moved to keyboard.h later
unsigned char kbd_buf_size = KBD_BUF_SIZE;
unsigned char kbd_buf[KBD_BUF_SIZE];//to be moved to keyboard.h later
unsigned char kbd_buf_idx;//points to empty element, for debug, remove later

//Variables
  unsigned char kbd_edge_count;  
  unsigned char kbd_hptr;//head pointer
			//Points to first occupied position 
			//in buffer
  unsigned char kbd_tptr;//tail pointer, points to first
			//empty position in buffer

  unsigned char kbd_shift;//belongs to kbd.h
  unsigned char kbd_numlock; //kbd.h
  unsigned char kbd_capslock; //kbd.h
  unsigned char kbd_status_led=0;//bit 0-scroll lock, 1-numlock, 2 capslock
//Functions
  void initialize_keyboard(void);
  void kbd_cts_off(void);
  void kbd_cts_on(void); 
  
  //kbd_getch()-Get a character from the keyboard buffer
  unsigned char kbd_getch(void);                 
  
  void kbd_send_cmd(unsigned char,unsigned char);
  
//End Keyboard

//STV5730                       
#define BLACK	0
#define BLUE	1
#define GREEN	2
#define CYAN	3
#define RED	4
#define MAGENTA	5
#define YELLOW	6
#define WHITE 	7
             
void STV_initialize(void);
void STV_send_16(unsigned char byte1, unsigned char byte0);
void STV_send_8(unsigned char byte0);  
                       
void STV_clrscr(void);
void STV_monitor(void);
void STV_video_mode(void);
void STV_full_page_mode(void); 

void STV_gotoxy(unsigned char x, unsigned char y);
void STV_printf(unsigned char flash*str, unsigned char color, unsigned char blink, unsigned char background);
void STV_print(unsigned char *str, unsigned char color, unsigned char blink, unsigned char background);
unsigned char STV_putch(unsigned char c, unsigned char color, unsigned char blink, unsigned char background);
void STV_putcode(unsigned char code, unsigned char color, unsigned char blink, unsigned char background);
//TESTING
  void STV_high_imp(void);
  void STV_low_imp(void);           
  void STV_set_mode_reg(void);
  void STV_set_mode_reg2(void);
  void STV_echo_settings(void);

//End STV5730           

//Sensors
//Connections                            
//	Sensor description		PORTA pin
#define PRESSURE_SENSOR_CHANNEL 	0        
#define ADC_SENSOR_CHANNEL0		1
#define ADC_SENSOR_CHANNEL1		2             
void initialize_sensors(void);
//get_pressure stores the pressure output in str
void get_pressure(unsigned char*str);   
//get_temperature stores temperature in str
void get_temperature(unsigned char*str);
//get_ADC(unsigned char*str,unsigned char channel) stores the channel inputs in str
void get_ADC(unsigned char*str, unsigned char channel);
//End sensors


//Main
unsigned char seconds,minutes,hours;
unsigned char day=1,month=1,year=2; 
unsigned char tminutes,thours,tday,tmonth,tyear;//temp variables

unsigned char UI_monitor_time;//counter for UI_monitor    
unsigned char STV_monitor_time;//counter for STV_monitor
unsigned char UI_show_sensor_time;
//Timer0 prescalar
#define TIMER0_PRESCALAR 0x04 //CK/256
//timer0 ovrfl int occurs every 256 * 256 / 8E6 s
//CK/256 - ovrfl every 8.192E-3s
#define UI_MONITOR_RELOAD	10 //.082s
#define STV_MONITOR_RELOAD	1  //.008s
#define UI_SHOW_SENSOR_RELOAD   61 //.500s
//End Main         

//Debug
unsigned char  test_kbd_entry = 0;
void UI_debug(void);